/* Soot - a J*va Optimization Framework
 * Copyright (C) 2008 Eric Bodden
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 */


import java.util.Date;
import java.util.Map;
import com.sidebuster.*;
import com.zkh.soot.analysis.RpcDataFlowAnalysis;

import soot.Body;
import soot.BodyTransformer;
import soot.G;
import soot.PackManager;
import soot.PhaseOptions;
import soot.Scene;
import soot.SootClass;
import soot.SootResolver;
import soot.Transform;
import soot.toolkits.graph.ExceptionalUnitGraph;
//import soot.toolkits.scalar.ForwardFlowAnalysis;
//import com.google.gwt.event.dom.client.*;
//import com.google.gwt.core.client.GWT;
public class MyMain {

	public static void main(String[] args) {
		SidebusterDemo demo = new SidebusterDemo();
		demo.selectTab(0);
		RpcDataFlowAnalysis.demo = demo;
		while (!demo.isDectectionStarted()) {
			try {
				Thread.sleep(500);
			} catch (InterruptedException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
		}
		Date start = new Date();
		demo.log2("Start detection phase on " + start + "\n");
		

		args[16]="asdfasdsf";
		args[16]=demo.getClassPath();
		args[12]=demo.getClassPath() + ";" + args[12];

		demo.log2(args[16]);
		demo.log2(demo.getTaintSourceFille());
		demo.log2(demo.getBehaviorModelFile());
		
		
		PackManager.v().getPack("jtp").add(
				new Transform("jtp.myTransform", new BodyTransformer() {

					protected void internalTransform(Body body, String phase, Map options) {
						new IntraCFGFlowAnalysis(new ExceptionalUnitGraph(body));
						// use G.v().out instead of System.out so that Soot can
						// redirect this output to the Eclipse console
						G.v().out.println(body.getMethod());
					}
					
				}));

		//Scene.v().addBasicClass("com.google.gwt.core.client.GWT", SootClass.HIERARCHY);
		//Scene.v().addBasicClass("com.google.gwt.user.client.ui.Button",SootClass.SIGNATURES);
		//Scene.v().addBasicClass("com.google.gwt.user.client.ui.Button",SootClass.HIERARCHY);
		//SootResolver.v().resolveClass("com.google.gwt.user.client.ui.Button",SootClass.HIERARCHY);
		//Scene.v().addBasicClass("com.google.gwt.event.dom.client.KeyUpEvent",SootClass.SIGNATURES);
		//Scene.v().addBasicClass("com.google.gwt.event.dom.client.KeyUpEvent",SootClass.HIERARCHY);
		//Scene.v().addBasicClass("com.google.gwt.user.client.ui.Button",SootClass.HIERARCHY);
		//SootResolver.v().resolveClass("com.google.gwt.event.dom.client.KeyUpEvent",SootClass.HIERARCHY);
		
		//Scene.v().addBasicClass("com.google.gwt.user.client.ui.Button",SootClass.HIERARCHY);
		//Scene.v().addBasicClass("com.google.gwt.event.dom.client.KeyUpEvent",SootClass.HIERARCHY);
		Scene.v().addBasicClass("com.zkh.gwt.test2.client.Test2$1MyHandler",SootClass.BODIES);
		
		//Scene.v().addBasicClass("com.google.gwt.user.client.ui.RootPanel",SootClass.HIERARCHY);
		//SootResolver.v().resolveClass("com.google.gwt.user.client.ui.RootPanel", SootClass.SIGNATURES);
		PhaseOptions.v().setPhaseOption("jb", "use-original-names:true");
		
		soot.Main.main(args);
		
		Date finish = new Date();

		long runtime = finish.getTime() - start.getTime();

		demo.log2(
		            "Analysis has taken "
		                + (runtime / 60000)
		                + " min. "
		                + ((runtime % 60000) / 1000)
		                + " sec.");
	}

	public static class MyAnalysis /*extends ForwardFlowAnalysis */ {

		public MyAnalysis(ExceptionalUnitGraph exceptionalUnitGraph) {
			//doAnalysis();
		}

	}

}