/**
 * 
 */
package com.zkh.soot.analysis;

import java.io.File;
import java.util.ArrayList;

import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import org.w3c.dom.Document;
import org.w3c.dom.Element;
import org.w3c.dom.Node;
import org.w3c.dom.NodeList;

/**
 * @author zkh
 *
 */
public class TaintSourceInterface {
	private Document doc;
	private ArrayList<TaintSource> taintList = new ArrayList<TaintSource>();
	
	/**
	 * 
	 */
	public TaintSourceInterface(String filename) throws Exception{
		  File file = new File(filename);
		  DocumentBuilderFactory dbf = DocumentBuilderFactory.newInstance();
		  DocumentBuilder db = dbf.newDocumentBuilder();
		  doc = db.parse(file);
		  doc.getDocumentElement().normalize();
		  parse();
	}
	
	public void parse() throws Exception{
		NodeList nodeLst = doc.getElementsByTagName("Widget");
		for (int s = 0; s < nodeLst.getLength(); s++) {
		    Node fstNode = nodeLst.item(s);
		    if (fstNode.getNodeType() == Node.ELEMENT_NODE) {
		    	Element fstElmnt = (Element) fstNode;
		    	TaintSource action = new TaintSource(
		    			fstElmnt.getAttribute("classes"),
		    			fstElmnt.getAttribute("method"),
		    			fstElmnt.getAttribute("name"),
		    			!fstElmnt.getAttribute("self").equals("false"),
		    			fstElmnt.getAttribute("api"));
		    	taintList.add(action);
		    }
		}
	}
	
	public ArrayList<TaintSource> getTaintSource() {
		return taintList;
	}
	
	public static void main(String[] args) {
		try {
			TaintSourceInterface parser = new TaintSourceInterface("F:\\prj\\soot\\workspace\\Test2\\model\\taintSource.xml");
			ArrayList<TaintSource> result = parser.getTaintSource();
			for(TaintSource action : result) {
				System.out.println("TaintSource " + action);
			}
		} catch (Exception e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		
	}

	
	
}
