/**
 * 
 */
package com.zkh.soot.analysis;

import java.io.File;
import java.io.FileOutputStream;
import java.util.ArrayList;

import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import org.w3c.dom.Document;
import org.w3c.dom.Element;
import org.w3c.dom.Node;
import org.w3c.dom.NodeList;


/**
 * @author zkh
 *
 */
public class UserBehaviorInterface {
	private Document doc;
	private ArrayList<UserAction> actionList = new ArrayList<UserAction>();
	
	/**
	 * 
	 */
	public UserBehaviorInterface(String filename) throws Exception{
		  File file = new File(filename);
		  DocumentBuilderFactory dbf = DocumentBuilderFactory.newInstance();
		  DocumentBuilder db = dbf.newDocumentBuilder();
		  doc = db.parse(file);
		  doc.getDocumentElement().normalize();
		  this.parse();

	}
	private void parse() throws Exception{
		NodeList nodeLst = doc.getElementsByTagName("Widget");
		for (int s = 0; s < nodeLst.getLength(); s++) {
		    Node fstNode = nodeLst.item(s);
		    if (fstNode.getNodeType() == Node.ELEMENT_NODE) {
		    	Element fstElmnt = (Element) fstNode;
		    	UserAction action = new UserAction(
		    			fstElmnt.getAttribute("classes"),
		    			fstElmnt.getAttribute("method"),
		    			fstElmnt.getAttribute("name"),
		    			!fstElmnt.getAttribute("self").equals("false"),
		    			fstElmnt.getAttribute("action"),
		    			fstElmnt.getAttribute("count"),		    		
		    			fstElmnt.getAttribute("value"));
		    	actionList.add(action);
		    }
		}		
	}
	public ArrayList<UserAction> getBehavior() {
		return actionList;
	}
	
	public void generateRerunGuidance(String filename) {
		try {
			FileOutputStream fp = new FileOutputStream(filename);
			for (UserAction action : actionList) {
				StringBuilder sb =  new StringBuilder();
				sb.append("<UserBehavior>\n");
				sb.append("<Widget ");
				sb.append(" type=\"" + action.getType() + "\"");
				sb.append(" name=\"" + action.getWidgetName() + "\"");
				sb.append(" self=\"" + action.getSelf() + "\"");
				sb.append(" action=\"" + action.getAction() + "\"");
				sb.append(" count=\"" + action.getCount() + "\"");

				
				sb.append(" />");
			}
		} catch (Exception e) {
		}
	}
	
	public static void main(String[] args) {
		try {
			UserBehaviorInterface parser = new UserBehaviorInterface("F:\\prj\\soot\\workspace\\Test2\\model\\userBehavior.xml");
			ArrayList<UserAction> result = parser.getBehavior();
			for(UserAction action : result) {
				System.out.println("UserAction " + action);
			}
		} catch (Exception e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		
	}

}
